//
// Event Test
// Test Events on Various UI Components
//

// Select Event Type:
// longpress, click, dblclick, doubletap
// longclick, pinch, singletap, twofingertap
// touchstart, touchmove, touchend, swipe
var eventType = "singletap";

// Select UI Type:
// window, button
var uiType = "window"; 


//
// Event Test
//

var win = Ti.UI.createWindow();
win.backgroundColor = '#13386c';
win.fullscreen = true;

// handle to ui component used to recieve user events
var uiElement = null;

// dispatch ui component type
// create component, set uiElement handle
// parent to main window
switch(uiType)
{
	case "button" :
		var eventButton = Ti.UI.createButton({height:100,width:300,bottom:100}); // ui sub-element used to fire events
		win.add(eventButton);
		uiElement = eventButton;
		break;

	case "window" :
		uiElement = win;
		break;
}


// Test UI Text
var instructionText = eventType + " " + uiType;
var removeListenerText = "remove " + eventType;
var addListenerText = "add " + eventType;

// Test Button
// Adds/Removes Event Listeners
var button = Ti.UI.createButton({
	title:removeListenerText,
	height:100,
	width:300,
	top:100
});

// Text for Add/Remove Button
var instructionLabel = Ti.UI.createLabel({
	color:'white',
	font:{fontSize:14,fontWeight:'bold',fontFamily:'Helvetica Neue'},
	bottom:5,
	textAlign:'center',
	text:instructionText,
	height:'auto',
	width:'auto'
});

// Message text at bottom of screen
var statusLabel = Ti.UI.createLabel({
	color:'white',
	font:{fontSize:14,fontFamily:'Helvetica Neue'},
	bottom:25,
	textAlign:'center',
	text:'',
	height:'auto',
	width:'auto'
});

win.add(instructionLabel);
win.add(statusLabel);
win.add(button);

function clear(o, newText)
{
	var text  = o.text;
	setTimeout(function()
	{
		if (o.text == text)
		{
			o.text = newText;
		}
	},1000);
}

function listener() {
	instructionLabel.text = eventType + " triggered";
	clear(instructionLabel, instructionText);
}

function addEventListener()
{
	uiElement.addEventListener(eventType, listener);
	button.removeEventListener('click', addEventListener);
	button.addEventListener('click', removeEventListener);
	button.title = removeListenerText;
}

function removeEventListener()
{
	uiElement.removeEventListener(eventType, listener);
	button.removeEventListener('click', removeEventListener);
	button.addEventListener('click', addEventListener);
	button.title = addListenerText;
}

button.addEventListener('click', removeEventListener);

uiElement.addEventListener(eventType, listener);

win.open();